Attribute VB_Name = "modDataBot"
Option Explicit

Function GetArena(ByVal mStr As String) As String
Dim I As Integer, S As String, S2 As String
mStr = TrimSpace(mStr)
If Left(mStr, 1) = "#" Then S = "#"
For I = 1 To Len(mStr)
 S2 = Mid(mStr, I, 1)
 If S2 >= "0" And S2 <= "9" Or S2 >= "A" And S2 <= "Z" Or S2 >= "a" And S2 <= "z" Then S = S + S2
Next
GetArena = S
End Function

Sub AddTerminal(BotIndex As Byte, mStr As String, mClr As Byte)
If TerminalLines(BotIndex) < MAX_TERMINALLINES Then TerminalLines(BotIndex) = TerminalLines(BotIndex) + 1

Dim I As Integer
For I = TerminalLines(BotIndex) To 2 Step -1 'from top line to bottom making one on top be one that was below
 Terminal(BotIndex, I).Msg = Terminal(BotIndex, I - 1).Msg
 Terminal(BotIndex, I).MsgType = Terminal(BotIndex, I - 1).MsgType
Next
Terminal(BotIndex, 1).Msg = mStr
Terminal(BotIndex, 1).MsgType = mClr

UpdateTerminal BotIndex

If LogTerminal Then
 If BotIndex > 0 Then
  AppendBytes "Terminal.log", Bots(BotIndex).Name + "<" + CStr(BotIndex) + "> " + mStr
 Else
  AppendBytes "Terminal.log", "Shell View " + mStr
 End If
End If
End Sub

Sub UpdateTerminal(BotIndex As Byte)
If BotIndex <> BotInFocus Then Exit Sub 'don't update screen with data that's not going to be shown

Dim I As Byte, linesshow As Byte, th As Byte, sh As Integer
th = frmTerminal.TextHeight("x")
sh = frmTerminal.ScaleHeight
linesshow = Abs(sh - 105 * 2) / th
If linesshow > TerminalLines(BotIndex) Then linesshow = TerminalLines(BotIndex)
frmTerminal.Cls
For I = 1 To linesshow
 frmTerminal.ForeColor = QBColor(Terminal(BotIndex, I).MsgType)
 frmTerminal.CurrentX = 105
 frmTerminal.CurrentY = (sh - 105 - th) - th * (I - 1)
 frmTerminal.Print Terminal(BotIndex, I).Msg
Next
End Sub

'call after changing .TotalUsers, botinfocus, or .type
Sub UpdateTitleBar(BotIndex As Byte)
If BotIndex <> BotInFocus Then Exit Sub 'don't update title bar with data that's not going to be shown

If BotIndex = 0 Then
 frmTerminal.Caption = App.Title & " - Shell View"
Else
 Dim S As String
 With Bots(BotIndex)
 Select Case .TotalUsers
 Case 0: S = " [Offline]"
 Case 1: S = " [1 player]"
 Case Else: S = " [" & CStr(.TotalUsers) & " players]"
 End Select
 frmTerminal.Caption = App.Title & "(" & CStr(BotIndex) & ") " & .Name & " " & BotName(.Type) & S
 End With
End If
End Sub

Sub EnableBot(BotIndex As Byte, UserID As Integer, Flag As Boolean)
With Bots(BotIndex)
If Flag Then
 If .Enabled Then
  PrivateMessage BotIndex, UserID, "Already enabled", 0
  Exit Sub
 Else
  .Enabled = 1
  PublicMessage BotIndex, "*arena " + .Name + " " + BotName(.Type) + " enabled by " + .Users(UserID).Name, 2 * .GameSound
  'PrivateMessage BotIndex, UserID, .Name + " " + BotName(.Type) + " is enabled", 2 * .gamesound
  If .Type = 6 Then NewRabbit BotIndex, 1
 End If
Else
 If .Enabled = 0 Then
  PrivateMessage BotIndex, UserID, "Already disabled", 0
  Exit Sub
 Else
  If .Type = 6 Then PublicMessage BotIndex, "*timereset", 0
  If (.Type = 1 Or .Type = 5) And .Type <> 7 Then
   If .Status = started Then PublicMessage BotIndex, "*lock", 0
  End If
  .Enabled = 0
  PublicMessage BotIndex, "*arena " + .Name + " " + BotName(.Type) + " disabled by " + .Users(UserID).Name, 1 * .GameSound
  'PrivateMessage BotIndex, UserID, .Name + " " + BotName(.Type) + " is disabled", 2 * .gamesound
 End If
End If
SetProfile "Bot" & (BotIndex), "Enabled", (.Enabled)
End With
End Sub

Sub EnableMonkeyBot(BotIndex As Byte, UserID As Integer, Flag As Boolean)
Dim S As String
With Bots(BotIndex)
If Flag Then
 If .Monkey Then
  PrivateMessage BotIndex, UserID, "MonkeyBot already enabled", 0
  Exit Sub
 Else
  If FTPList(BotIndex).FTP_Name > "" Then
   PrivateMessage BotIndex, UserID, "MonkeyBot: Busy downloading. Try again in 30 seconds", 0
   Exit Sub
  ElseIf .HasSysop = 0 Then
   PrivateMessage BotIndex, UserID, "MonkeyBot requires sysop power to edit settings", 0
   Exit Sub
  Else
   PublicMessage BotIndex, "?set Security:SecurityKickoff:0", 0
   DownloadSettings BotIndex
   .Monkey = 1
   PrivateMessage BotIndex, UserID, "MonkeyBot is enabled", 0
  End If
 End If
Else
 If .Monkey Then
  Dim I As Integer, I2 As Integer
  PublicMessage BotIndex, "*arena NOTICE: Server settings resetting to normal...", 2
  For I = 1 To LastCategory(BotIndex)
   For I2 = 0 To Setting(BotIndex, I).LastKey
    With Setting(BotIndex, I).CategorySettings(I2)
    If .Changed Then S = S + Setting(BotIndex, I).CategoryName + ":" + .KeyName + ":" + CStr(.Original) + Chr(0)
    End With
   Next
  Next
  For I = 1 To Len(S) Step 480
   If I >= Len(S) - 480 Then
    If I = 1 Then
     UDPSend BotIndex, Chr(0) + Chr(9) + Chr(&H1D) + Left(S, 479), True
     I = 0
    Else
     UDPSend BotIndex, Chr(0) + Chr(9) + Mid(S, I, 480), True
    End If
   Else
    If I = 1 Then
     UDPSend BotIndex, Chr(0) + Chr(8) + Chr(&H1D) + Left(S, 479), True
     I = 0
    Else
     UDPSend BotIndex, Chr(0) + Chr(8) + Mid(S, I, 480), True
    End If
   End If
  Next
  PublicMessage BotIndex, "*shipreset", 0
  .Monkey = 0
  PrivateMessage BotIndex, UserID, "MonkeyBot is disabled", 0
 Else
  PrivateMessage BotIndex, UserID, "MonkeyBot already disabled", 0
  Exit Sub
 End If
End If
SetProfile "Bot" & (BotIndex), "Monkey", (.Monkey)
End With
End Sub

Sub ConnectBot(BotIndex As Byte)
With Bots(BotIndex)
.SSEncrKey = SSKey01
UDPSend BotIndex, Chr(0) + Chr(1) + GetStringL(.SSEncrKey) + Chr(1) + Chr(0), False
'''Chr(196) & Chr(172) & Chr(231) & Chr(139)
'''UDPSend BotIndex, Chr(0) + Chr(1) + Chr(196) & Chr(172) & Chr(231) & Chr(139) + Chr(1) + Chr(0), False
AddTerminal BotIndex, "CONNECTING [" + Long2IP(.Sock.sin_addr) + ": " + CStr(ntohs(.Sock.sin_port)) + "]", 10
.AutoConnect = 1 'spawning a bot or got disconnected by server, so start auto-reconnecting in tmrPeriodic
End With
If BotIndex > LastConnectingBot Then LastConnectingBot = BotIndex
End Sub

'The spawn function. BotIndex is bot we want to spawn. if already spawned. look for next available
Sub SpawnBot(BotIndex As Byte, Type2, Name As String, IP As String, Port As Integer)
Dim L As Long
On Error GoTo FlyPaper

If Bots(BotIndex).AutoConnect Or Bots(BotIndex).Spawning Or Bots(BotIndex).SpawnConnected Then UnloadBot BotIndex, 0 'can try to spawn already spawned from -spawnlocal/-spawnremote. must have this or the next available bot will have his sets overwritten by already spawned bot thus creating dupes and a dupe player cannot log on

If Not frmTerminal.tmrPeriodic.Enabled Then StartWinsock 'no bots are online; starting program or restarting default bot after unloading all the bots

If Bots(BotIndex).SpawnConnected = 0 Then GoTo wantedslotisopen

For BotIndex = 1 To MAX_BOTS 'have to be able to scan thru all bots declared in Bots() array
wantedslotisopen:
 With Bots(BotIndex)
 If .SpawnConnected = 0 Then
  AddTerminal BotIndex, "CREATING SPAWN: " + Name + " " + BotName(Type2), 10
  .Name = Name
  .Type = Val(GetType(Type2, 1, "N"))
  UpdateTitleBar BotIndex
  .GotSync = 1 'don't let tmrPeriodic timer send any syncs while it's connecting
'  .LastPacketID = -1
  L = socket(2&, 2&, 0&)
  bind L, .Sock, 16&
  .SockID = L
  WSAAsyncSelect L, WinsockWindow, 5150&, FD_ALL
  .Sock.sin_addr = IP2Long(IP)
  .Sock.sin_port = htons(Port)
  ConnectBot BotIndex
  .Spawning = 1 'trying to spawn a bot (of course not going to connect if bot has bad ip/port setting or not connected to internet with remote ip/port)
  If Not frmTerminal.tmrPeriodic.Enabled Then 'Spawning a very first bot (from available 10). start the timer threads. tmrPeriodic is for games and auto-spawning every 20 seconds
   frmTerminal.tmrPeriodic.Enabled = 1
'   frmTerminal.tmrSecures.Enabled = 1
  End If
  Exit Sub
 End If
 End With
Next
Exit Sub

FlyPaper:
AddTerminal BotIndex, "Error detected in SpawnBot(): " + Err.Description, 12
Resume Next
End Sub

Sub UnloadBot(BotIndex As Byte, FromPlayer As Boolean)
Dim I As Integer
On Error GoTo FlyPaper
With Bots(BotIndex)
.AutoConnect = 0
.Spawning = 0
LeaveServer BotIndex
WSAAsyncSelect .SockID, WinsockWindow, 0&, 0&
closesocket .SockID
ResetSession BotIndex '.spawnconnected will be reset here
.SockID = 0
.Sock.sin_addr = 0
.Sock.sin_port = 0
End With

AddTerminal BotIndex, "SPAWN UNLOADED" & IIf(FromPlayer, " BY OPERATOR", ""), 12

For I = LastBot To 1 Step -1
 If Bots(I).SpawnConnected Then LastBot = I: GoTo nowcheckconnecting 'get most last bot still connected
Next
LastBot = 0 'all bots are offline
AddTerminal 0, Time & " " & Date & " All bots offline", 12
nowcheckconnecting:
For I = LastConnectingBot To 1 Step -1
 If Bots(I).AutoConnect Or Bots(I).Spawning Or Bots(I).SpawnConnected Then LastConnectingBot = I: Exit Sub 'some are still trying to connect. let them in tmrPeriodic timer
Next
LastConnectingBot = 0
frmTerminal.tmrPeriodic.Enabled = 0
'frmTerminal.tmrSecures.Enabled = 0
EndWinsock 'exit winsock stack catching function to prevent crashes
Exit Sub

FlyPaper:
AddTerminal BotIndex, "Error detected in UnloadBot(): " + Err.Description, 12
Resume Next
End Sub

Sub ResetSession(BotIndex As Byte)
'ClearSecures BotIndex
'ClearBacklog BotIndex
ClearACKs BotIndex 'used for backlog

With Bots(BotIndex)
.SpawnConnected = 0 'unloaded bot or got disconnected by remote server (will be trying to reconnect)
.TotalSent = 0
.TotalReceived = 0
.TotalSecuresSent = 0
.KeepAliveCounter = 0
'.UseQueue = 0
'.AvgPing = 0
'.TotalPings = 0
.GotSync = 1
.DownloadingSettings = 0
'.LastPacketID = -1
End With
End Sub

Sub UnloadAllBots(FromPlayer As Boolean)
Do Until LastConnectingBot < 1
 UnloadBot LastConnectingBot, FromPlayer
Loop
End Sub

'Player database management
Function FindUser(BotIndex As Byte, ByVal Name As String) As Integer
Dim I As Integer
Name = LCase(Name)
FindUser = -1
For I = 0 To Bots(BotIndex).LastUser
 If Name = LCase(Bots(BotIndex).Users(I).Name) Then FindUser = I: Exit Function
Next
End Function

Sub LoginUser(BotIndex As Byte, UserID As Integer, Name As String, Squad As String, Freq As Integer, Ship As Byte, Wins As Integer, Losses As Integer, Points As Long)
Dim I As Integer, S As String, I2 As Integer, b As Byte

If UserID > MAX_USERS Then
 AddTerminal 0, "Player database is full.", 12
 PublicMessage BotIndex, "*arena " + "ATTN: Player database is full. " + Name + " will not be able to participate in games", 0
 Exit Sub
End If

With Bots(BotIndex).Users(UserID)
.Name = Name
.Squad = LCase(Squad)
.Freq = Freq
.Ship = Ship
.Playing = 0
If Bots(BotIndex).Type = 7 Then 'unlike in elim, freeelim doesn't reset scores everytime game starts. so we don't need score data from subspace's biller, ours is counted from 0 when game starts and not updated from biller (subspace)
 .Wins = 0
 .Losses = 0
Else
 .Wins = Wins
 .Losses = Losses
End If
.Points = Points
.GamePoints = 0
'.ProfileLoginCode = "" 'not used anymore

'code below makes it messier, but at least made the zoneop function work; if more than 1 bot spawned, that bot *moderator/*smoderator/*sysop ed a zone op like the previous bot did thus taking the power away. code below fixed that
For I2 = BotIndex - 1 To 1 Step -1
 If Bots(I2).SpawnConnected Then
  If (Bots(I2).LocalIP = Bots(BotIndex).LocalIP And Bots(I2).LocalPort = Bots(BotIndex).LocalPort Or Bots(I2).RemoteIP = Bots(BotIndex).RemoteIP And Bots(I2).RemotePort = Bots(BotIndex).RemotePort) And Bots(I2).Arena = Bots(BotIndex).Arena Then GoTo zoneopalreadyset 'there are more than 1 bots in 1 zone, so we need only 1 to give zoneop powers, play login sound and get alias data
 End If
Next
If .ZLevel = 1 Then PrivateMessage BotIndex, UserID, "*moderator", 0
If .ZLevel = 2 Then PrivateMessage BotIndex, UserID, "*smoderator", 0
If .ZLevel = 3 Then PrivateMessage BotIndex, UserID, "*sysop", 0
zoneopalreadyset:
MyPlaySound Bots(BotIndex).LoginSound, SND_ASYNC
If AliasFinder Then PrivateMessage BotIndex, UserID, "*info", 0  'will start adding new aliases when new player enters. sends *info and receives in public_chat message the infos
End With

With Bots(BotIndex)
'If .Enabled Then
' If .Type = 1 Or .Type = 2 Or .Type = 5 Or .Type = 6 Or .Type = 7 Then
  'S = IIf(LCase(.Welcome) = "default", "Welcome! " + GetStatus(BotIndex, UserID) + ". Type -help for command reference", .Welcome)
  S = .Welcome
  I = InStr(LCase(S), "[default]")
  If I > 0 Then S = Left(S, I - 1) + "Welcome! " + GetStatus(BotIndex, UserID) + ". Type -help for command reference" + Mid(S, I + 8 + 1)
  If S > "" Then PrivateMessage BotIndex, UserID, S, 0
' End If
'End If
.TotalUsers = .TotalUsers + 1
If UserID > .LastUser Then .LastUser = UserID
End With
UpdateTitleBar BotIndex

CheckAnsweringMachine BotIndex, Name
HandleShipChanges BotIndex, UserID 'need to call here cause when player comes in a ship, "shipchange" packet won't be received
End Sub

Sub LogoffUser(BotIndex As Byte, UserID As Integer)
Dim I As Integer
With Bots(BotIndex)
.Users(UserID).Name = ""
.Users(UserID).BLevel = 0
.Users(UserID).ZLevel = 0
.TotalUsers = .TotalUsers - 1
If UserID = .LastUser Then
 For I = .LastUser - 1 To 0 Step -1
  If .Users(I).Name > "" Then .LastUser = I: Exit For
 Next
End If
End With
UpdateTitleBar BotIndex
End Sub

Sub LogoffAllUsers(BotIndex As Byte)
Dim I As Integer
With Bots(BotIndex)
For I = 0 To .LastUser
 .Users(I).Name = ""
 .Users(I).BLevel = 0
 .Users(I).ZLevel = 0
Next
.TotalUsers = 0
.LastUser = 0
End With
UpdateTitleBar BotIndex
End Sub

'used before a game starts
Sub AddAllPlaying(BotIndex As Byte, ZombieFreqOnly As Boolean)
Dim I As Integer
With Bots(BotIndex)
.TotalPlaying = 0
If ZombieFreqOnly Then 'when there's a zombie bot type, .Playing=true is the humans (on freq0), and .Playing=false is zombies (on freq1)
 For I = 0 To .LastUser
  If .Users(I).Name > "" And .Users(I).Ship < 8 And .Users(I).Freq = 0 Then AddPlaying BotIndex, I
 Next
Else
 For I = 0 To .LastUser
  If .Users(I).Name > "" And .Users(I).Ship < 8 Then AddPlaying BotIndex, I
 Next
End If
End With
End Sub

Sub AddPlaying(BotIndex As Byte, UserID As Integer)
With Bots(BotIndex)
If InStr(LCase(GameBans), LCase(.Users(UserID).Name)) > 0 Then Exit Sub
.TotalPlaying = .TotalPlaying + 1
.Users(UserID).Playing = 1
If .Type = 3 Then IncrementCount .Users(UserID).Name
End With
End Sub

Sub DelPlaying(BotIndex As Byte, UserID As Integer)
With Bots(BotIndex)
If .TotalPlaying = 0 Then Exit Sub
.TotalPlaying = .TotalPlaying - 1
.Users(UserID).Playing = 0
End With
End Sub

Function GetPlaying(BotIndex As Byte) As String
Dim I As Integer, S As String
For I = 0 To Bots(BotIndex).LastUser
 If Bots(BotIndex).Users(I).Playing Then S = S + Bots(BotIndex).Users(I).Name + ", "
Next
GetPlaying = Left(S, Len(S) + 2 * (S > 0))
End Function

'used before a game starts
Function CheckPlayerCount(BotIndex As Byte, Required As Integer, ZombieFreqOnly As Boolean) As Boolean
Dim I As Integer, I2 As Integer
With Bots(BotIndex)
If ZombieFreqOnly Then
 For I = 0 To .LastUser
  If InStr(LCase(GameBans), LCase(.Users(I).Name)) = 0 And .Users(I).Name > "" And .Users(I).Ship < 8 And .Users(I).Freq = 1 Then I2 = I2 + 1
 Next
Else
 For I = 0 To .LastUser
  If InStr(LCase(GameBans), LCase(.Users(I).Name)) = 0 And .Users(I).Name > "" And .Users(I).Ship < 8 Then I2 = I2 + 1
 Next
End If
End With
CheckPlayerCount = (I2 >= Required)
End Function

'Capital ship counts
Sub CheckDate(Name As String)
If Day(Now) <> Val(GetProfile("Capital Ship Date", Name, "", 1)) Then
 SetProfile "Capital Ship Count", Name, "0"
 SetProfile "Capital Ship Date", Name, Day(Now)
End If
End Sub

Function GetTotal(Name As String) As Integer
GetTotal = Val(GetProfile("Capital Ship Total", Name, "", 1))
End Function

Function GetCount(Name As String) As Integer
CheckDate Name
GetCount = Val(GetProfile("Capital Ship Count", Name, "", 1))
End Function

Sub IncrementCount(Name As String)
CheckDate Name
SetProfile "Capital Ship Count", Name, CStr(Val(GetProfile("Capital Ship Count", Name, "", 1)) + 1)
SetProfile "Capital Ship Total", Name, CStr(Val(GetProfile("Capital Ship Total", Name, "", 1)) + 1)
End Sub

Function GetRules(BotIndex As Byte) As String
With Bots(BotIndex)
Select Case .Type
Case 1
 Select Case .ElimType
 Case Vanilla: GetRules = "All on own freqs. Die " + CStr(.MaxDeaths) + " times and you are out. Last player wins"
 Case javelim: GetRules = "All on own freqs. Die " + CStr(.MaxDeaths) + " times and you are out. Last player wins"
 Case javrace: GetRules = "All on own freqs. Kill " + CStr(.MaxDeaths) + " times and you are the winner"
 Case Race: GetRules = "All on own freqs. Kill " + CStr(.MaxDeaths) + " times and you are the winner"
 Case teamelim: GetRules = "All on even teams. Die " + CStr(.MaxDeaths) + " times and you are out. Last player wins"
 Case wbelim: GetRules = "All on own freqs. Die " + CStr(.MaxDeaths) + " times and you are out. Last player wins"
 Case wbrace: GetRules = "All on own freqs. Kill " + CStr(.MaxDeaths) + " times and you are the winner"
 Case GolfElim: GetRules = "All on own freqs. Start with 1 point. Kill to gain a point. Die to lose a point. Lose all points are you are out"
 End Select
Case 2: GetRules = "All players start on freq 0 as humans. One player changes to freq 1 as zombie. Die once and you become zombie. Last human wins"
Case 3: GetRules = "Freq0 uses ships 1 2 3, Freq1 uses ships 4 5 6, Ships 7 and 8 are capital ships - one per team"
Case 4: GetRules = "Freq0 uses ships 1 2 3 4, Freq1 uses ships 5 6 7 8"
Case 5: GetRules = "Each player on own freq. Die and you are captured to your killer's freq. Player who 0wns all others wins"
Case 6: GetRules = "One player is chosen at random to be a BountyRabbit(with 5k bty). Players who kill him become BountyRabbits"
Case 7: GetRules = "All on own freqs. First player to get " + CStr(.MaxDeaths) + " kills and not die " + CStr(.MaxDeaths) + " times wins. Ships specs aren't forced. Ships aren't reset. Freqs aren't separated. Scores aren't reset. Loss is still added to ranks if quit/went to spec."
End Select
End With
End Function

Function GetStatus(BotIndex As Byte, UserID As Integer) As String
Dim S As String
With Bots(BotIndex)
If .Enabled Then
 If .Type = 1 Then 'elim
  Select Case .Status
  Case CHECK: GetStatus = "Elim will start when 2 players enter"
  Case VOTE_GAME: GetStatus = "Voting on what game to play next: 1-Elim,2-Race,3-WBElim,4-WBRace,5-JavElim,6-JavRace,7-TeamElim,8-Golf"
  Case VOTE_DEATHS
   Select Case .ElimType
   Case Vanilla: GetStatus = "We are playing Elimination. Vote: number of deaths? (1-10). Current is " + CStr(.MaxDeaths)
   Case Race: GetStatus = "We are playing Race. Vote: number of kills? (1-10). Current is " + CStr(.MaxDeaths)
   Case wbelim: GetStatus = "We are playing Warbird Elimination. Vote: number of deaths? (1-10). Current is " + CStr(.MaxDeaths)
   Case wbrace: GetStatus = "We are playing Warbird Race. Vote: number of kills? (1-10). Current is " + CStr(.MaxDeaths)
   Case javelim: GetStatus = "We are playing Javelin Elimination. Vote: number of deaths? (1-10). Current is " + CStr(.MaxDeaths)
   Case javrace: GetStatus = "We are playing Javelin Race. Vote: number of kills? (1-10). Current is " + CStr(.MaxDeaths)
   Case teamelim: GetStatus = "We are playing Team Elimination. Vote: number of deaths? (1-10). Current is " + CStr(.MaxDeaths)
   Case GolfElim: GetStatus = "We are playing Golf Elimination. Vote: max number of points? (1-10). Current is " + CStr(.MaxDeaths)
   End Select
  Case WAIT_AFTER_RESULTS
   Select Case .ElimType
   Case Vanilla: GetStatus = "We are playing Elimination to " + CStr(.MaxDeaths) + "; Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case Race: GetStatus = "We are playing Race to " + CStr(.MaxDeaths) + ". Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case wbelim: GetStatus = "We are playing Warbird Elimination to " + CStr(.MaxDeaths) + "; Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case wbrace: GetStatus = "We are playing Warbird Race to " + CStr(.MaxDeaths) + ". Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case javelim: GetStatus = "We are playing Javelin Elimination to " + CStr(.MaxDeaths) + "; Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case javrace: GetStatus = "We are playing Javelin Race to " + CStr(.MaxDeaths) + ". Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case teamelim: GetStatus = "We are playing Team Elimination to " + CStr(.MaxDeaths) + "; Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   Case GolfElim: GetStatus = "We are playing Golf Elimination up to " + CStr(.MaxDeaths) + " points; Next game will start in " + CStr(10 - .GameCounter) + " seconds"
   End Select
  Case started
   Select Case .ElimType
   Case Vanilla: GetStatus = "We are playing Elimination to " + CStr(.MaxDeaths) + "; " + CStr(.TotalPlaying) + " left"
   Case Race: GetStatus = "We are playing Race to " + CStr(.MaxDeaths)
   Case wbelim: GetStatus = "We are playing Warbird Elimination to " + CStr(.MaxDeaths) + "; " + CStr(.TotalPlaying) + " left"
   Case wbrace: GetStatus = "We are playing Warbird Race to " + CStr(.MaxDeaths)
   Case javelim: GetStatus = "We are playing Javelin Elimination to " + CStr(.MaxDeaths) + "; " + CStr(.TotalPlaying) + " left"
   Case javrace: GetStatus = "We are playing Javelin Race to " + CStr(.MaxDeaths)
   Case teamelim: GetStatus = "We are playing Team Elimination to " + CStr(.MaxDeaths) + "; " + CStr(.TotalPlaying) + " left"
   Case GolfElim: GetStatus = "We are playing Golf Elimination up to " + CStr(.MaxDeaths) + " points; " + CStr(.TotalPlaying) + " left"
   End Select
  End Select
 ElseIf .Type = 2 Then 'zombie
  Select Case .Status
  Case CHECK: GetStatus = "Zombies will start when 3 players enter"
  Case started: GetStatus = "We are playing zombies; " + CStr(.TotalPlaying) + " humans left"
  Case WAIT: GetStatus = "Waiting for someone to become the first zombie on freq 1"
  Case PAUSE: GetStatus = "Zombies will start in " + CStr(20 - .GameCounter) + " seconds"
  End Select
 ElseIf .Type = 5 Then 'conquer
  Select Case .Status
  Case CHECK: GetStatus = "Conquer will start when 4 players enter"
  Case WAIT: GetStatus = "Conquer will start in " + CStr(30 - .GameCounter) + " seconds"
  Case started: GetStatus = "We are playing conquer"
  End Select
 ElseIf .Type = 6 Then 'bounty rabbit
  If .BountyRabbitUserIndex = -1 Then
   GetStatus = "BountyRabbit will start when 2 players enter"
  Else
   GetStatus = "Current BountyRabbit(tm): " + .Users(.BountyRabbitUserIndex).Name + "  Type ?time for time remaining"
  End If
 ElseIf .Type = 7 Then 'freeelim
  Select Case .Status
  Case CHECK: GetStatus = "FreeElim will start when 2 players enter"
  Case VOTE_DEATHS: GetStatus = "We are playing FreeElim. Vote: number of deaths? (1-10). Current is " + CStr(.MaxDeaths)
  Case WAIT_AFTER_RESULTS: GetStatus = "We are playing FreeElim to " + CStr(.MaxDeaths) + "; Next game will start in " + CStr(10 - .GameCounter) + " seconds"
  Case started
   S = "We are playing FreeElim to " + CStr(.MaxDeaths) + ". "
   Dim I As Integer
   For I = 0 To .LastUser
    If .Users(I).Name > "" Then 'if not logged out. if in spec on freeelim and not died .maxdeaths, then can still play
     If .Users(I).Losses >= .MaxDeaths Then
      S = S & .Users(I).Name + " is out (" + CStr(.Users(I).Losses) + " of " + CStr(.MaxDeaths) + " deaths). "
     ElseIf .Users(I).Playing Then
      If I = UserID Then 'kills/deaths will not be given to players other than the one who asks -status
       S = S & "You are playing; Kills/Deaths " + CStr(.Users(I).Wins) + "/" + CStr(.Users(I).Losses) + ". "
      Else
       S = S & .Users(I).Name + " is playing. "
      End If
     End If
    End If
   Next
   GetStatus = Left(S, Len(S) - 1)
  End Select
 Else
  GetStatus = "I am " + BotName(.Type) + ". There is no status to report"
 End If
Else
 GetStatus = .Name + " " + BotName(.Type) + " is disabled"
End If
End With
End Function

'Ranking statistics
'The ranking system is weird. I didn't change the system, but made the code a little smaller. I guess that's how it is. It still says I'm #1 even if my score is not highest
Function GetRank(ByVal Name As String) As String
Dim L As Long, L2 As Long, L3 As Long, Better As Long, D As Double, D2 As Double
Name = LCase(Name)
For L = 1 To LastRank
 If Ranks(L).Name = Name Then
  D = Ranks(L).GamesWon / Ranks(L).GamesPlayed
  L2 = Ranks(L).Wins - Ranks(L).Losses
  For L3 = 1 To LastRank
   With Ranks(L3)
   If .GamesWon > Ranks(L).GamesWon Then
    Better = Better + 1
   ElseIf .GamesWon = Ranks(L).GamesWon Then
    D2 = .GamesWon / .GamesPlayed
    If D2 > D Or D2 = D And .Wins - .Losses > L2 Then Better = Better + 1
   End If
   End With
  Next
  GetRank = Name + " - W/L: " + CStr(Ranks(L).Wins) + "/" + CStr(Ranks(L).Losses) + ", Games won: " + CStr(Ranks(L).GamesWon) + " of " + CStr(Ranks(L).GamesPlayed) + ", Ranked #" + CStr(Better + 1) + " of " + CStr(LastRank)
  Exit Function
 End If
Next
GetRank = "No record for " + Name
End Function

Sub UpdateRank(ByVal Name As String, Won As Boolean, Wins As Integer, Losses As Integer)
Name = LCase(Name)
Dim L As Long
For L = 1 To LastRank
 If Ranks(L).Name = Name Then
  With Ranks(L)
  .GamesPlayed = .GamesPlayed + 1
  .GamesWon = .GamesWon - Won
  .Wins = .Wins + Wins
  .Losses = .Losses + Losses
  End With
  Exit Sub
 End If
Next
If LastRank = MAX_RANKS Then
 AddTerminal 0, "Ranks database is full. " + Name + " cannot be added.", 12
 Exit Sub
End If
LastRank = LastRank + 1
With Ranks(LastRank)
.Name = Name
.GamesPlayed = 1
.GamesWon = -Won
.Wins = Wins
.Losses = Losses
End With
End Sub

Sub LoadRanks()
Dim freefilenumber As Integer, S As String, I As Integer, I2 As Integer, I3 As Integer, I4 As Integer, I5 As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Ranks.txt" For Input As freefilenumber
 LastRank = 0
 Do Until EOF(freefilenumber)
  Line Input #freefilenumber, S
  I = InStr(S, "")
  I2 = InStr(I + 1, S, "")
  I3 = InStr(I2 + 1, S, "")
  I4 = InStr(I3 + 1, S, "")
  If I > 0 Then 'don't just put 'If I Then'; it won't work the 2nd time you run the program
   LastRank = LastRank + 1
   With Ranks(LastRank)
   .Name = LCase(Left(S, I - 1))
   If I2 > 0 Then
    .Wins = Val(Mid(S, I + 1, I2 - I - 1))
    If I3 > 0 Then
     .Losses = Val(Mid(S, I2 + 1, I3 - I2 - 1))
     If I4 > 0 Then
      .GamesWon = Val(Mid(S, I3 + 1, I4 - I3 - 1))
      .GamesPlayed = Val(Mid(S, I4 + 1))
      LastRank = LastRank + (.GamesPlayed = 0) 'if edited the file and set .gamesplayed to 0
     End If
    End If
   End If
   End With
  End If
  If LastRank = MAX_RANKS Then Exit Do
 Loop
ErrHandler:
Close freefilenumber

AddTerminal 0, "Rank records loaded. " + CStr(LastRank) + " entries", 9
End Sub

Sub SaveRanks()
Dim L As Long, freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Ranks.txt" For Output As freefilenumber
 Print #freefilenumber, "NAME,WINS,LOSSES,GAMESWON,GAMESPLAYED"
 For L = 1 To LastRank
  With Ranks(L)
  Print #freefilenumber, .Name; ""; CStr(.Wins); ""; CStr(.Losses); ""; CStr(.GamesWon); ""; CStr(.GamesPlayed)
  End With
 Next
ErrHandler:
Close freefilenumber
End Sub

'Player aliasing
Sub LoadAliases()
Dim freefilenumber As Integer, S As String, I As Integer, I2 As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Aliases.txt" For Input As freefilenumber
 LastAlias = 0
 Do Until EOF(freefilenumber)
  Line Input #freefilenumber, S
  I = InStr(S, "")
  I2 = InStr(I + 1, S, "")
  If I > 0 Then
   LastAlias = LastAlias + 1
   Alias(LastAlias).Name = LCase(Left(S, I - 1))
   If I2 > 0 Then
    Alias(LastAlias).IP = Mid(S, I + 1, I2 - I - 1)
    Alias(LastAlias).MacID = Mid(S, I2 + 1)
   End If
  End If
  If LastAlias = MAX_ALIASES Then Exit Do
 Loop
 StartOfNewAlias = 0  'means it won't resave the same data if no new players are logged in
ErrHandler:
Close freefilenumber
AddTerminal 0, "Aliases loaded. " + CStr(LastAlias) + " logged aliases", 9
End Sub

Sub SaveAliases()
If StartOfNewAlias = 0 Then Exit Sub
Dim L As Long, freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Aliases.txt" For Append As freefilenumber
 If StartOfNewAlias = 1 Then Print #freefilenumber, "USER,IP,MACID"
 For L = StartOfNewAlias To LastAlias
  Print #freefilenumber, Alias(L).Name; ""; Alias(L).IP; ""; Alias(L).MacID
 Next
 StartOfNewAlias = 0
ErrHandler:
Close freefilenumber
End Sub

'Get all other names the player has been using while AliasFinder was enabled
Function GetAliases(ByVal Name As String) As String
Dim L As Long, L2 As Long, S As String
Name = LCase(Name)
For L = 1 To LastAlias
 If Alias(L).Name = Name Then
  For L2 = 1 To LastAlias
   If (Alias(L2).MacID = Alias(L).MacID Or Alias(L2).IP = Alias(L).IP) And L2 <> L Then S = S + Alias(L2).Name + ", "
  Next
 End If
Next
GetAliases = Left(S, Len(S) + 2 * (S > ""))
End Function

Function GetAliasMacID(ByVal Name As String) As String
Dim L As Long
Name = LCase(Name)
For L = 1 To LastAlias
 If LCase(Alias(L).Name) = Name Then GetAliasMacID = Alias(L).MacID: Exit Function
Next
End Function

'Get aliases of only players that have used more than 1
Function GetAliasesX2() As String
Dim L As Long, L2 As Long, S As String, foundmorethan1 As Boolean
For L = 1 To LastAlias
 If InStr(S, Alias(L).Name) = 0 Then
  foundmorethan1 = 0
  For L2 = L + 1 To LastAlias
   If (Alias(L2).MacID = Alias(L).MacID Or Alias(L2).IP = Alias(L).IP) Then
    If Not foundmorethan1 Then S = S + "<" + Alias(L).Name + ">"
    S = S + "<" + Alias(L2).Name + ">"
    foundmorethan1 = 1
   End If
  Next
  If foundmorethan1 Then S = S + ","
 End If
Next
GetAliasesX2 = Left(S, Len(S) + (S > ""))
End Function

'Profiles
Sub LoadProfiles()
Dim freefilenumber As Integer, S As String, I As Integer, I2 As Integer, I3 As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Profiles.txt" For Input As freefilenumber
 LastProfile = 0
 Do Until EOF(freefilenumber)
  Line Input #freefilenumber, S
  I = InStr(S, "")
  I2 = InStr(I + 1, S, "")
  I3 = InStr(I2 + 1, S, "")
  If I > 0 Then
   LastProfile = LastProfile + 1
   With Profile(LastProfile)
   .Name = Left(S, I - 1)
   If I2 > 0 Then
    .MacID = Mid(S, I + 1, I2 - I - 1)
    If I3 > 0 Then
     .Hidden = Mid(S, I2 + 1, I3 - I2 - 1)
     .Profile = Mid(S, I3 + 1) & IIf(Right(Mid(S, I3 + 1), 1) = "", "", "")
    End If
   End If
   End With
  End If
  If LastProfile = MAX_PROFILES Then Exit Do
 Loop
ErrHandler:
Close freefilenumber

AddTerminal 0, "Profiles loaded. " + CStr(LastProfile) + " entries", 9
End Sub

Sub SaveProfiles()
Dim L As Long, freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Profiles.txt" For Output As freefilenumber
 Print #freefilenumber, "NAME,MACID,HIDDEN,PROFILE"
 For L = 1 To LastProfile
  With Profile(L)
  Print #freefilenumber, .Name; ""; .MacID; ""; .Hidden; ""; .Profile
  End With
 Next
ErrHandler:
Close freefilenumber
End Sub

'Organize frequencies
Sub SeparateTeams(BotIndex As Byte)
Dim CTeam(9998) As Integer, I As Integer, I2 As Integer
With Bots(BotIndex)
For I = 0 To .LastUser
 If .Users(I).Name > "" And .Users(I).Ship < 8 Then
  If CTeam(.Users(I).Freq) = 1 Then
   Do
    I2 = Int(Rnd * 9999)
   Loop While CTeam(I2) = 1
   .Users(I).Freq = I2
   CTeam(I2) = 1
   PrivateMessage BotIndex, I, "*setfreq " + CStr(I2), 0
  Else
   CTeam(.Users(I).Freq) = 1
  End If
 End If
Next
End With
End Sub

Sub MergeTeams(BotIndex As Byte)
Dim CTeam(1) As Integer, I As Integer

With Bots(BotIndex)
For I = 0 To .LastUser
 If .Users(I).Name > "" And .Users(I).Ship < 8 Then
  Select Case .Users(I).Freq
  Case 0: CTeam(0) = CTeam(0) + 1
  Case 1: CTeam(1) = CTeam(1) + 1
  End Select
 End If
Next
For I = 0 To .LastUser
 If .Users(I).Name > "" And .Users(I).Ship < 8 Then
  Select Case .Users(I).Freq
  Case 0
  Case 1
  Case Else
   If CTeam(0) > CTeam(1) Then
    CTeam(1) = CTeam(1) + 1
    PrivateMessage BotIndex, I, "*setfreq 1", 0
   Else
    CTeam(0) = CTeam(0) + 1
    PrivateMessage BotIndex, I, "*setfreq 0", 0
   End If
  End Select
 End If
Next
End With
End Sub

Function CheckTeamElimVictory(BotIndex As Byte) As Integer
Dim I As Integer, CTeam(1) As Integer
For I = 0 To Bots(BotIndex).LastUser
 If Bots(BotIndex).Users(I).Playing Then
  If Bots(BotIndex).Users(I).Freq = 0 Then
   CTeam(0) = 1
  ElseIf Bots(BotIndex).Users(I).Freq = 1 Then
   CTeam(1) = 1
  End If
 End If
Next
If CTeam(0) = 0 Then
 CheckTeamElimVictory = 1
ElseIf CTeam(1) = 0 Then
 CheckTeamElimVictory = 0
Else
 CheckTeamElimVictory = -1
End If
End Function

'BountyGame
Sub NewRabbit(BotIndex As Byte, Event2 As Byte)
Dim I As Integer, b As Byte, MagicHat(1 To MAX_USERS) As Integer, TotalCards As Integer
'Event
'0-op changed rabbit,1-enabled bot,2-gameoverrabbit,3-rabbit specced
'4-player entered with no bounty rabbits,5-player quit,6-banned/unbanned from games
With Bots(BotIndex)
For I = 0 To .LastUser
 If InStr(LCase(GameBans), LCase(.Users(I).Name)) = 0 And .Users(I).Name > "" And .Users(I).Ship < 8 Then
  TotalCards = TotalCards + 1
  MagicHat(TotalCards) = I
 End If
Next
If TotalCards < 2 Then
 .BountyRabbitUserIndex = -1
 If Event2 <> 1 Then
  PublicMessage BotIndex, "*arena Bounty rabbit will start when 2 players enter", 0
  If Event2 <> 4 Then PublicMessage BotIndex, "*timereset", 0
 End If
Else
 I = MagicHat(Int(Rnd * TotalCards) + 1)
 PublicMessage BotIndex, "*arena New BountyRabbit: " + .Users(I).Name, 0
 PublicMessage BotIndex, "*timer 10", 0
 If .HasSysop Then
  PrivateMessage BotIndex, I, "*prize 5000", 0
 Else
  For b = 1 To 50
   PrivateMessage BotIndex, I, "*prize 100", 0
  Next
 End If
 .BountyRabbitUserIndex = I
End If
End With
End Sub

Sub CapturedRabbit(BotIndex As Byte, UserID As Integer, KillerUserID As Integer)
With Bots(BotIndex)
Select Case CInt(Rnd * 12)
Case 0: PublicMessage BotIndex, "*arena The BountyRabbit(tm) has struck again! Zone in panic! " + .Users(KillerUserID).Name + " now at large! $5000 reward!", 25 * .GameSound
Case 1: PublicMessage BotIndex, "*arena Hop. hop. hop. Another rabbit bit the dust. " + .Users(KillerUserID).Name + " now holds the 5000 bounty!", 7 * .GameSound
Case 2: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + "(old rabbit) kb " + .Users(KillerUserID).Name + "(new rabbit with 5000 bounty)", 22 * .GameSound
Case 3: PublicMessage BotIndex, "*arena Uh oh, " + .Users(KillerUserID).Name + " is growing ears! He's contracted the BountyRabbit(tm) virus from " + .Users(UserID).Name + "!", 13 * .GameSound
Case 4: PublicMessage BotIndex, "*arena " + .Users(KillerUserID).Name + " is now the BountyRabbit! Type ?target=5000 for a Big Light Blue indicator on your radar", 19 * .GameSound
Case 5: PublicMessage BotIndex, "*arena " + .Users(KillerUserID).Name + " has been rabbitified! Type ?time to check how much time is left until he wins", 20 * .GameSound
Case 6: PublicMessage BotIndex, "*arena Another waskalie wabbit has been sighted: " + .Users(KillerUserID).Name + ". And it's wabbit-hunting season!", 18 * .GameSound
Case 7: PublicMessage BotIndex, "*arena " + .Users(KillerUserID).Name + " has vanquished the villainous old rabbit! He has been granted a $5000 reward", 27 * .GameSound
Case 8: PublicMessage BotIndex, "*arena A new bounty rabbit has been born and it ain't pretty! " + .Users(KillerUserID).Name + " holds the sucker", 32 * .GameSound
Case 9: PublicMessage BotIndex, "*arena Uh oh, " + .Users(KillerUserID).Name + " is growing ears! He's contracted the BountyRabbit(tm) virus from " + .Users(UserID).Name + "!", 4 * .GameSound
Case 10: PublicMessage BotIndex, "*arena The BountyRabbit(tm) has struck again! Zone in panic! " + .Users(KillerUserID).Name + " now at large! $5000 reward!", 17 * .GameSound
Case 11: PublicMessage BotIndex, "*arena Zee rebbeet, " + .Users(KillerUserID).Name + ", veell be-a in zee stoo suun inuoogh. $5000 preece-a teg", 21 * .GameSound
Case 12: PublicMessage BotIndex, "*arena Psst! " + Mid(.Users(KillerUserID).Name, 2) + Left(.Users(KillerUserID).Name, 1) + "ay has ethay OuntyRabbitbay irusvay! Asspay it onyay!", 16 * .GameSound
End Select
PublicMessage BotIndex, "*timereset", 0
PublicMessage BotIndex, "*timer 10", 0
.BountyRabbitUserIndex = KillerUserID
If .HasSysop Then
 PrivateMessage BotIndex, KillerUserID, "*prize 5000", 0
Else
 Dim b As Byte
 For b = 1 To 50
  PrivateMessage BotIndex, KillerUserID, "*prize 100", 0
 Next
End If
End With
End Sub

Sub GameOverRabbit(BotIndex As Byte)
PublicMessage BotIndex, "*arena 10 minutes has elapsed! " + Bots(BotIndex).Users(Bots(BotIndex).BountyRabbitUserIndex).Name + " survived the duration as BountyRabbit!", 103 * Abs(Bots(BotIndex).GameSound)
NewRabbit BotIndex, 2
End Sub

Sub FindHiders(BotIndex As Byte, Distance As Integer)
Dim I As Integer, I2 As Integer, S As String, Hiders(1 To MAX_USERS) As Integer, TotalHiders As Integer

With Bots(BotIndex)
For I = 0 To .LastUser
 If InStr(LCase(GameBans), LCase(.Users(I).Name)) = 0 And .Users(I).Name > "" And .Users(I).Ship < 8 Then
  For I2 = 0 To .LastUser
   If InStr(LCase(GameBans), LCase(.Users(I2).Name)) = 0 And .Users(I2).Name > "" And .Users(I2).Ship < 8 And I2 <> I Then
    If Abs(.Users(I).X - .Users(I2).X) <= Distance And Abs(.Users(I).Y - .Users(I2).Y) <= Distance Then GoTo found
   End If
  Next
  TotalHiders = TotalHiders + 1
  Hiders(TotalHiders) = I
 End If
found:
Next
For I = 1 To TotalHiders
 S = S + .Users(Hiders(I)).Name + " @ " + GetPlayerCoords(BotIndex, Hiders(I)) + ", "
Next
If TotalHiders > 0 Then
 S = Left(S, Len(S) - 2)
 For I = 1 To Len(S) Step 82
  PublicMessage BotIndex, "*arena Hiders: " + Mid(S, I, 82), 0
 Next
End If
End With
End Sub

Function TeamUnevenCount(BotIndex As Byte) As Integer
Dim I As Integer, C1 As Integer, C2 As Integer
With Bots(BotIndex)
For I = 0 To .LastUser
 If .Users(I).Name > "" And .Users(I).Ship < 8 Then
  Select Case .Users(I).Freq
  Case 0: C1 = C1 + 1
  Case 1: C2 = C2 + 1
  End Select
 End If
Next
End With
TeamUnevenCount = Abs(C1 - C2)
End Function

Sub EvenTeams(BotIndex As Byte)
Dim I As Integer, C1 As Integer, C2 As Integer
With Bots(BotIndex)
For I = 0 To .LastUser
 If .Users(I).Name > "" And .Users(I).Ship < 8 Then
  Select Case .Users(I).Freq
  Case 0: C1 = C1 + 1
  Case 1: C2 = C2 + 1
  End Select
 End If
Next
If C1 > C2 Then
 For I = 0 To .LastUser
  If .Users(I).Name > "" And .Users(I).Ship < 8 And .Users(I).Freq = 0 Then
   PrivateMessage BotIndex, I, "*setfreq 1", 0
   C1 = C1 - 1: C2 = C2 + 1
   If C1 - C2 <= 1 Then Exit Sub
  End If
 Next
Else
 For I = 0 To .LastUser
  If .Users(I).Name > "" And .Users(I).Ship < 8 And .Users(I).Freq = 1 Then
   PrivateMessage BotIndex, I, "*setfreq 0", 0
   C1 = C1 + 1: C2 = C2 - 1
   If C2 - C1 <= 1 Then Exit Sub
  End If
 Next
End If
End With
End Sub

Function AddVote(Vote As String, MinVal As Integer, MaxVal As Integer, DefaultVotes, ClearVotes As Boolean) As Byte
Dim I As Integer, Best As Integer, TotalAnyVotes As Integer
Static v(10) As Integer 'in v(0) will be '0' votes counted, in v(1) will be '1' votes counted, and so on. The v array that gets most will be outputed to AddVote. Static means it will remain in memory as this sub is exited.

Vote = Val(Vote)
If Vote < MinVal Then Vote = MinVal
If Vote > MaxVal Then Vote = MaxVal

If Not ClearVotes Then v(Vote) = v(Vote) + 1 'count votes only when not erasing them or getting default value (when not voted)

For I = MinVal To MaxVal
 If v(I) > v(Best) Then Best = I
 TotalAnyVotes = TotalAnyVotes + v(I)
Next
If TotalAnyVotes = 0 Then Best = DefaultVotes 'so players wouldn't have to always revote usual votes
If Best < MinVal Then Best = MinVal
AddVote = Best

If ClearVotes Then Erase v 'clear vote array so the next time we start another voting we don't continue with previous results
End Function

Function IsPublicArena(Arena As String) As Boolean
IsPublicArena = Arena = "" Or IsNumeric(Arena)
End Function

'Conquer! database and utilities
Sub SetupConquer(BotIndex As Byte)
Dim I As Integer
TotalFreqs(BotIndex) = 0
With Bots(BotIndex)
For I = 0 To .LastUser
 If InStr(LCase(GameBans), LCase(.Users(I).Name)) = 0 And .Users(I).Name > "" And .Users(I).Ship < 8 Then AddConquerPlayer BotIndex, I, True
Next
End With
End Sub

Sub AddConquerPlayer(BotIndex As Byte, UserID As Integer, NewTeam As Boolean)
Dim I As Integer
If NewTeam Then 'Create a new freq for the new player.
 Do
  I = CInt(Rnd * 9999)
 Loop While GetOwner(BotIndex, I) <> -1
 PrivateMessage BotIndex, UserID, "*setfreq " + CStr(I), 0
 Bots(BotIndex).Users(UserID).Freq = I

 If TotalFreqs(BotIndex) < MAX_USERS Then TotalFreqs(BotIndex) = TotalFreqs(BotIndex) + 1 'reached last player in dimensioned array
 Conquer(BotIndex, TotalFreqs(BotIndex)).Freq = I
 Conquer(BotIndex, TotalFreqs(BotIndex)).InitialOwner = UserID

 For I = 1 To Conquer(BotIndex, TotalFreqs(BotIndex)).TotalCurrent
  Conquer(BotIndex, TotalFreqs(BotIndex)).CurrentPlayers(I) = 0
 Next
 Conquer(BotIndex, TotalFreqs(BotIndex)).TotalCurrent = 0
Else
 'Add the player to a random freq.
 I = Int(Rnd * TotalFreqs(BotIndex)) + 1
 With Conquer(BotIndex, I)
 If .TotalCurrent < MAX_USERS Then .TotalCurrent = .TotalCurrent + 1
 .CurrentPlayers(.TotalCurrent) = UserID
 End With
 Bots(BotIndex).Users(UserID).Freq = Conquer(BotIndex, I).Freq
 PrivateMessage BotIndex, UserID, "*setfreq " + CStr(Conquer(BotIndex, I).Freq), 0
End If
End Sub

Sub ConquerPlayer(BotIndex As Byte, UserID As Integer, KillerUserID As Integer)
On Error GoTo ErrHandler

Dim I As Integer, I2 As Integer
Dim KillerFreq As Integer, KillerIndex As Integer
Dim PlayerFreq As Integer, PlayerIndex As Integer

If UserID = KillerUserID Then Exit Sub

For I = 1 To TotalFreqs(BotIndex)
 With Conquer(BotIndex, I)
 'Search owner slots for matches.
 If .InitialOwner = UserID Then
  PlayerFreq = I
  PlayerIndex = 0
  If KillerFreq <> 0 Then GoTo LeaveLoop
 ElseIf .InitialOwner = KillerUserID Then
  KillerFreq = I
  KillerIndex = 0
  If PlayerFreq <> 0 Then GoTo LeaveLoop
 End If
 For I2 = 1 To .TotalCurrent
  'Search owned player slots for matches.
  If .CurrentPlayers(I2) = UserID Then
   PlayerFreq = I
   PlayerIndex = I2
   If KillerFreq <> 0 Then GoTo LeaveLoop
  ElseIf .CurrentPlayers(I2) = KillerUserID Then
   KillerFreq = I
   KillerIndex = I2
   If PlayerFreq <> 0 Then GoTo LeaveLoop
  End If
 Next
 End With
Next

If PlayerFreq = 0 Then AddTerminal BotIndex, "Corrupt DBase (P): " + Bots(BotIndex).Users(UserID).Name + " not found.", 12
If KillerFreq = 0 Then AddTerminal BotIndex, "Corrupt DBase (K): " + Bots(BotIndex).Users(KillerUserID).Name + " not found.", 12
Exit Sub

LeaveLoop:
If PlayerFreq = KillerFreq Then Exit Sub

With Conquer(BotIndex, PlayerFreq)
If PlayerIndex = 0 Then
 If Conquer(BotIndex, PlayerFreq).TotalCurrent > 0 Then
  'Announce the action to be taken.
  PublicMessage BotIndex, "*arena " + Bots(BotIndex).Users(Conquer(BotIndex, KillerFreq).InitialOwner).Name + "'s empire has captured a monarch: " + Bots(BotIndex).Users(UserID).Name + ". All his serfs have been enslaved to " + Bots(BotIndex).Users(Conquer(BotIndex, KillerFreq).InitialOwner).Name + ".", 13 * Abs(Bots(BotIndex).GameSound)
  'Move all owned players to the killer's freq.
  For I = 1 To .TotalCurrent
   If Conquer(BotIndex, KillerFreq).TotalCurrent < MAX_USERS Then Conquer(BotIndex, KillerFreq).TotalCurrent = Conquer(BotIndex, KillerFreq).TotalCurrent + 1
   Conquer(BotIndex, KillerFreq).CurrentPlayers(Conquer(BotIndex, KillerFreq).TotalCurrent) = .CurrentPlayers(I)
   Bots(BotIndex).Users(.CurrentPlayers(I)).Freq = Conquer(BotIndex, KillerFreq).Freq
   PrivateMessage BotIndex, .CurrentPlayers(I), "*setfreq " + CStr(Conquer(BotIndex, KillerFreq).Freq), 0
  Next
  .TotalCurrent = 0
 Else
  'Announce the action to be taken.
  PrivateMessage BotIndex, UserID, "Captured by " + Bots(BotIndex).Users(Conquer(BotIndex, KillerFreq).InitialOwner).Name + "'s empire!", (1 + CInt(Rnd * 26)) * Abs(Bots(BotIndex).GameSound)
  If KillerIndex = 0 Then
   PrivateMessage BotIndex, Conquer(BotIndex, KillerFreq).InitialOwner, Bots(BotIndex).Users(UserID).Name + " has been captured.", 0
  Else
   PrivateMessage BotIndex, Conquer(BotIndex, KillerFreq).InitialOwner, Bots(BotIndex).Users(UserID).Name + " has been captured by your loyal subject: " + Bots(BotIndex).Users(KillerUserID).Name, 0
  End If
 End If
 'Remove the killed player's freq.
 If KillerFreq > PlayerFreq Then KillerFreq = KillerFreq - 1
 TotalFreqs(BotIndex) = TotalFreqs(BotIndex) - 1
 For I = PlayerFreq To TotalFreqs(BotIndex)
  Conquer(BotIndex, I) = Conquer(BotIndex, I + 1)
 Next
Else
 'Announce the action to be taken.
 PrivateMessage BotIndex, UserID, "Captured by " + Bots(BotIndex).Users(Conquer(BotIndex, KillerFreq).InitialOwner).Name + "'s empire!", (1 + CInt(Rnd * 26)) * Abs(Bots(BotIndex).GameSound)
 If KillerIndex = 0 Then
  PrivateMessage BotIndex, Conquer(BotIndex, KillerFreq).InitialOwner, Bots(BotIndex).Users(UserID).Name + " has been captured.", 0
 Else
  PrivateMessage BotIndex, Conquer(BotIndex, KillerFreq).InitialOwner, Bots(BotIndex).Users(UserID).Name + " has been captured by your loyal subject: " + Bots(BotIndex).Users(KillerUserID).Name, 0
 End If
 PrivateMessage BotIndex, Conquer(BotIndex, PlayerFreq).InitialOwner, Bots(BotIndex).Users(UserID).Name + " has been captured by an opposing empire.", 0
 'Remove the killed player from his freq.
 .TotalCurrent = .TotalCurrent - 1
 For I = PlayerIndex To .TotalCurrent
  .CurrentPlayers(I) = .CurrentPlayers(I + 1)
 Next
End If
End With

With Conquer(BotIndex, KillerFreq)
'Add the killed player to his killer's freq.
If .TotalCurrent < MAX_USERS Then .TotalCurrent = .TotalCurrent + 1
.CurrentPlayers(.TotalCurrent) = UserID
Bots(BotIndex).Users(UserID).Freq = .Freq
PrivateMessage BotIndex, UserID, "*setfreq " + CStr(.Freq), 0
End With

CheckConquerVictory BotIndex
Exit Sub

ErrHandler:
AddTerminal BotIndex, "Error occured in ConquerPlayer(): " + Err.Description, 12
End Sub

Sub CheckConquerVictory(BotIndex As Byte)
If TotalFreqs(BotIndex) < 2 Then
 PublicMessage BotIndex, "*lock", 0
 Select Case TotalFreqs(BotIndex)
 Case 0: PublicMessage BotIndex, "*arena GAME OVER. No winner.", 103 * Abs(Bots(BotIndex).GameSound)
 Case 1: PublicMessage BotIndex, "*arena GAME OVER. Winner: " + Bots(BotIndex).Users(Conquer(BotIndex, 1).InitialOwner).Name, 103 * Abs(Bots(BotIndex).GameSound)
 End Select
 If Not CheckPlayerCount(BotIndex, 4, False) Then PublicMessage BotIndex, "*arena Conquer will start again when 4 players enter", 0
 Bots(BotIndex).Status = CHECK
End If
End Sub

Function GetTeam(BotIndex As Byte, UserID As Integer) As Integer
Dim I As Integer, I2 As Integer
For I = 1 To TotalFreqs(BotIndex)
 With Conquer(BotIndex, I)
 For I2 = 1 To .TotalCurrent
  If .CurrentPlayers(I2) = UserID Then
   GetTeam = I
   Exit Function
  End If
 Next
 End With
Next
GetTeam = -1
End Function

Function GetOwner(BotIndex As Byte, Freq As Integer) As Integer
Dim I As Integer
For I = 1 To TotalFreqs(BotIndex)
 If Conquer(BotIndex, I).Freq = Freq Then
  GetOwner = Conquer(BotIndex, I).InitialOwner
  Exit Function
 End If
Next
GetOwner = -1
End Function

Sub ConquerCheckFreq(BotIndex As Byte, UserID As Integer)
Dim I As Integer, I2 As Integer, I3 As Integer
For I = 1 To TotalFreqs(BotIndex)
 If Conquer(BotIndex, I).InitialOwner = UserID Then
  If Bots(BotIndex).Users(UserID).Ship = 8 Then
   If Conquer(BotIndex, I).TotalCurrent > 0 Then
    'Choose a random replacement ruler.
    I3 = Int(Rnd * Conquer(BotIndex, I).TotalCurrent) + 1
    Conquer(BotIndex, I).InitialOwner = Conquer(BotIndex, I).CurrentPlayers(I3)
    'Remove a player.
    Conquer(BotIndex, I).TotalCurrent = Conquer(BotIndex, I).TotalCurrent - 1
    For I2 = I3 To Conquer(BotIndex, I).TotalCurrent
     Conquer(BotIndex, I).CurrentPlayers(I2) = Conquer(BotIndex, I).CurrentPlayers(I2 + 1)
    Next
    'Announce the action.
    PublicMessage BotIndex, "*arena " + Bots(BotIndex).Users(UserID).Name + "'s empire crumbles in his absence.  Amidst the confusion his slaves revolt, proclaiming " + Bots(BotIndex).Users(Conquer(BotIndex, I).InitialOwner).Name + " as the new ruler.", 13 * Abs(Bots(BotIndex).GameSound)
   Else
    'Remove a freq.
    TotalFreqs(BotIndex) = TotalFreqs(BotIndex) - 1
    For I3 = I To TotalFreqs(BotIndex)
     Conquer(BotIndex, I3) = Conquer(BotIndex, I3 + 1)
    Next
    CheckConquerVictory BotIndex
   End If
  ElseIf Bots(BotIndex).Users(UserID).Freq <> Conquer(BotIndex, I).Freq Then
   'Change this player back to the correct freq.
   PrivateMessage BotIndex, UserID, "*setfreq " + CStr(Conquer(BotIndex, I).Freq), 0
  End If
  Exit Sub
 End If
 For I2 = 1 To Conquer(BotIndex, I).TotalCurrent
  If Conquer(BotIndex, I).CurrentPlayers(I2) = UserID Then
   If Bots(BotIndex).Users(UserID).Ship = 8 Then
    'Remove this player.
    Conquer(BotIndex, I).TotalCurrent = Conquer(BotIndex, I).TotalCurrent - 1
    For I3 = I2 To Conquer(BotIndex, I).TotalCurrent
     Conquer(BotIndex, I).CurrentPlayers(I3) = Conquer(BotIndex, I).CurrentPlayers(I3 + 1)
    Next
   ElseIf Bots(BotIndex).Users(UserID).Freq <> Conquer(BotIndex, I).Freq Then
    'Change this player back to the correct freq.
    PrivateMessage BotIndex, UserID, "*setfreq " + CStr(Conquer(BotIndex, I).Freq), 0
   End If
   Exit Sub
  End If
 Next
Next

If Bots(BotIndex).Users(UserID).Ship < 8 Then AddConquerPlayer BotIndex, UserID, False 'Add the new player.
End Sub

Sub KillConquerPlayer(BotIndex As Byte, UserID As Integer)
Dim I As Integer, I2 As Integer, I3 As Integer
For I = 1 To TotalFreqs(BotIndex)
 If Conquer(BotIndex, I).InitialOwner = UserID Then
  If Conquer(BotIndex, I).TotalCurrent > 0 Then
   'Choose a random replacement ruler.
   I3 = Int(Rnd * Conquer(BotIndex, I).TotalCurrent) + 1
   Conquer(BotIndex, I).InitialOwner = Conquer(BotIndex, I).CurrentPlayers(I3)
   'Remove a player.
   Conquer(BotIndex, I).TotalCurrent = Conquer(BotIndex, I).TotalCurrent - 1
   For I2 = I3 To Conquer(BotIndex, I).TotalCurrent
    Conquer(BotIndex, I).CurrentPlayers(I2) = Conquer(BotIndex, I).CurrentPlayers(I2 + 1)
   Next
   'Announce the action.
   PublicMessage BotIndex, "*arena " + Bots(BotIndex).Users(UserID).Name + "'s empire crumbles in his absence.  Amidst the confusion his slaves revolt, proclaiming " + Bots(BotIndex).Users(Conquer(BotIndex, I).InitialOwner).Name + " as the new leader.", 13 * Abs(Bots(BotIndex).GameSound)
  Else
   'Remove a freq.
   TotalFreqs(BotIndex) = TotalFreqs(BotIndex) - 1
   For I3 = I To TotalFreqs(BotIndex)
    Conquer(BotIndex, I3) = Conquer(BotIndex, I3 + 1)
   Next
   CheckConquerVictory BotIndex
  End If
  Exit Sub
 End If
 For I2 = 1 To Conquer(BotIndex, I).TotalCurrent
  If Conquer(BotIndex, I).CurrentPlayers(I2) = UserID Then
   'Remove a player.
   Conquer(BotIndex, I).TotalCurrent = Conquer(BotIndex, I).TotalCurrent - 1
   For I3 = I2 To Conquer(BotIndex, I).TotalCurrent
    Conquer(BotIndex, I).CurrentPlayers(I3) = Conquer(BotIndex, I).CurrentPlayers(I3 + 1)
   Next
   Exit Sub
  End If
 Next
Next
End Sub

'Scores loging
Sub LoadScores()
Dim freefilenumber As Integer, S As String, I As Integer, I2 As Integer, I3 As Integer, I4 As Integer, I5 As Integer, I6 As Integer, I7 As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Scores.txt" For Input As freefilenumber
 LastScores = 0
 Do Until EOF(freefilenumber)
  Line Input #freefilenumber, S
  I = InStr(S, "")
  I2 = InStr(I + 1, S, "")
  I3 = InStr(I2 + 1, S, "")
  I4 = InStr(I3 + 1, S, "")
  I5 = InStr(I4 + 1, S, "")
  I6 = InStr(I5 + 1, S, "")
  I7 = InStr(I6 + 1, S, "")
  If I > 0 Then
   LastScores = LastScores + 1
   With Scores(LastScores)
   If I2 > 0 Then
    .Arena = LCase(Mid(S, I + 1, I2 - I - 1))
    If I3 > 0 Then
     .Freq(0).Wins = Val(Mid(S, I2 + 1, I3 - I2 - 1))
     If I4 > 0 Then
      .Freq(0).Losses = Val(Mid(S, I3 + 1, I4 - I3 - 1))
      If I5 > 0 Then
       .Freq(0).FlagVictories = Val(Mid(S, I4 + 1, I5 - I4 - 1))
       If I6 > 0 Then
        .Freq(1).Wins = Val(Mid(S, I5 + 1, I6 - I5 - 1))
        If I7 > 0 Then
         .Freq(1).Losses = Val(Mid(S, I6 + 1, I7 - I6 - 1))
         .Freq(1).FlagVictories = Val(Mid(S, I7 + 1))
        End If
       End If
      End If
     End If
    End If
   End If
   End With
  End If
  If LastScores = MAX_SCORES Then Exit Do
 Loop
ErrHandler:
Close freefilenumber
AddTerminal 0, "Team scores loaded. " + CStr(LastScores) + " arena entries", 9
End Sub

Sub SaveScores()
Dim b As Byte, freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Scores.txt" For Output As freefilenumber
 Print #freefilenumber, "ARENA,FREQ0 WINS,FREQ0 LOSSES,FREQ0 FLAG VICTORIES,FREQ1 WINS,FREQ1 LOSSES,FREQ1 FLAG VICTORIES"
 For b = 1 To LastScores
  With Scores(b)
  Print #freefilenumber, .Arena; ""; CStr(.Freq(0).Wins); ""; CStr(.Freq(0).Losses); ""; CStr(.Freq(0).FlagVictories); ""; CStr(.Freq(1).Wins); ""; CStr(.Freq(1).Losses); ""; CStr(.Freq(1).FlagVictories)
  End With
 Next
ErrHandler:
Close freefilenumber
End Sub

Sub AddWin(BotIndex As Byte, Freq As Integer)
If Bots(BotIndex).LogScores = 0 Or Freq > 1 Or Freq < 0 Then Exit Sub

Dim b As Byte
For b = 1 To LastScores
 If Scores(b).Arena = Bots(BotIndex).Arena Then
  Scores(b).Freq(Freq).Wins = Scores(b).Freq(Freq).Wins + 1
  Exit Sub
 End If
Next

If LastScores = MAX_SCORES Then
 AddTerminal 0, "Scores database is full.", 12
 Exit Sub
End If

LastScores = LastScores + 1
Scores(LastScores).Arena = Bots(BotIndex).Arena
Scores(LastScores).Freq(Freq).Wins = "1"
End Sub

Sub AddLoss(BotIndex As Byte, Freq As Integer)
If Bots(BotIndex).LogScores = 0 Or Freq > 1 Or Freq < 0 Then Exit Sub

Dim b As Byte
For b = 1 To LastScores
 If Scores(b).Arena = Bots(BotIndex).Arena Then
  Scores(b).Freq(Freq).Losses = Scores(b).Freq(Freq).Losses + 1
  Exit Sub
 End If
Next

If LastScores = MAX_SCORES Then
 AddTerminal 0, "Scores database is full.", 12
 Exit Sub
End If

LastScores = LastScores + 1
Scores(LastScores).Arena = Bots(BotIndex).Arena
Scores(LastScores).Freq(Freq).Losses = "1"
End Sub

Sub AddFlagVictory(BotIndex As Byte, Freq As Integer)
If Bots(BotIndex).LogScores = 0 Or Freq > 1 Or Freq < 0 Then Exit Sub

Dim b As Byte
For b = 1 To LastScores
 If Scores(b).Arena = Bots(BotIndex).Arena Then
  Scores(b).Freq(Freq).FlagVictories = Scores(b).Freq(Freq).FlagVictories + 1
  Exit Sub
 End If
Next

If LastScores = MAX_SCORES Then
 AddTerminal 0, "Scores database is full.", 12
 Exit Sub
End If

LastScores = LastScores + 1
Scores(LastScores).Arena = Bots(BotIndex).Arena
Scores(LastScores).Freq(Freq).FlagVictories = "1"
End Sub

'Player score changes
Sub HandleScoreChanges(BotIndex As Byte, UserID As Integer, KillerUserID As Integer)
On Error GoTo FlyPaper

With Bots(BotIndex)
If KillerUserID > -1 And .KillPrize > 0 Then
 PrivateMessage BotIndex, KillerUserID, "*prize #" + CStr(.KillPrize), 0
End If
If .AutoSpec > 0 And .AutoSpec <= .Users(UserID).Losses Then
 PrivateMessage BotIndex, UserID, "*spec", 0
 PrivateMessage BotIndex, UserID, "*spec", 0
End If
If .Type = 1 And .Enabled And .Status = started Then 'elim
 Select Case .ElimType
 Case Vanilla
  If .Users(UserID).Losses >= .MaxDeaths Then
   If .Users(UserID).Playing Then
    PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " is out. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    DelPlaying BotIndex, UserID
    UpdateRank .Users(UserID).Name, False, .Users(UserID).Wins, .Users(UserID).Losses
   End If
  End If
 Case Race
  If .Users(UserID).Wins >= .MaxDeaths Then
   PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(UserID).Name, 103 * .GameSound
   PublicMessage BotIndex, "*lock", 0
   TeamM BotIndex, "You may enter", 0
   .Status = CHECK
   UpdateRank .Users(UserID).Name, True, .Users(UserID).Wins, .Users(UserID).Losses
  End If
 Case wbelim
  If .Users(UserID).Losses >= .MaxDeaths Then
   If .Users(UserID).Playing Then
    PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " is out. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    DelPlaying BotIndex, UserID
    UpdateRank .Users(UserID).Name, False, .Users(UserID).Wins, .Users(UserID).Losses
   End If
  End If
 Case wbrace
  If .Users(UserID).Wins >= .MaxDeaths Then
   PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(UserID).Name, 2 * .GameSound
   PublicMessage BotIndex, "*lock", 0
   TeamM BotIndex, "You may enter", 0
   .LockShips = 0
   .Status = CHECK
   UpdateRank .Users(UserID).Name, True, .Users(UserID).Wins, .Users(UserID).Losses
  End If
 Case javelim
  If .Users(UserID).Losses >= .MaxDeaths Then
   If .Users(UserID).Playing Then
    PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " is out. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    DelPlaying BotIndex, UserID
    UpdateRank .Users(UserID).Name, False, .Users(UserID).Wins, .Users(UserID).Losses
   End If
  End If
 Case javrace
  If .Users(UserID).Wins >= .MaxDeaths Then
   PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(UserID).Name, 2 * .GameSound
   PublicMessage BotIndex, "*lock", 0
   TeamM BotIndex, "You may enter", 0
   .LockShips = 0
   .Status = CHECK
   UpdateRank .Users(UserID).Name, True, .Users(UserID).Wins, .Users(UserID).Losses
  End If
 Case teamelim
  If .Users(UserID).Losses >= .MaxDeaths Then
   If .Users(UserID).Playing Then
    PublicMessage BotIndex, "*arena " + .Users(UserID).Name + CStr(.Users(UserID).Freq) + " is out. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    PrivateMessage BotIndex, UserID, "*spec", 0
    DelPlaying BotIndex, UserID
    UpdateRank .Users(UserID).Name, False, .Users(UserID).Wins, .Users(UserID).Losses
   End If
  End If
 Case GolfElim
  If KillerUserID > -1 Then
   If .Users(KillerUserID).GamePoints < .MaxDeaths Then
    .Users(KillerUserID).GamePoints = .Users(KillerUserID).GamePoints + 1
   End If
   .Users(UserID).GamePoints = .Users(UserID).GamePoints - 1
   If .Users(UserID).GamePoints = 0 Then
    PublicMessage BotIndex, "*arena " + .Users(KillerUserID).Name + CStr(.Users(KillerUserID).GamePoints) + " +pts " + .Users(UserID).Name + " is out. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
    If .Users(UserID).Playing Then
     PrivateMessage BotIndex, UserID, "*spec", 0
     PrivateMessage BotIndex, UserID, "*spec", 0
     DelPlaying BotIndex, UserID
     UpdateRank .Users(UserID).Name, False, .Users(UserID).Wins, .Users(UserID).Losses
    End If
   Else
    PublicMessage BotIndex, "*arena " + .Users(UserID).Name + CStr(.Users(UserID).GamePoints) + " -pts kb " + .Users(KillerUserID).Name + CStr(.Users(KillerUserID).GamePoints) + " +pts", 0
   End If
  End If
 End Select
ElseIf .Type = 2 And .Status = started And .Enabled Then 'zombie
 If .Users(UserID).Playing And KillerUserID > -1 Then
  Select Case CInt(Rnd * 9)
  Case 0: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " has been zombified! BrainZ!", 0
  Case 1: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " has been zombified", 0
  Case 2: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " was taken in by the dark side", 13 * .GameSound
  Case 3: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " has seen the benefits of an all-brain diet", 0
  Case 4: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " seems a little green.. and thirsty for brains!", 0
  Case 5: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " had his grey-matter feasted upon", 0
  Case 6: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " is now one of the undead", 0
  Case 7: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " was annexed by the zombie horde!", 0
  Case 8: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " has become ""one with the zombie""", 0
  Case 9: PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " strayed into zombie territory and was eatten", 0
  End Select
  PrivateMessage BotIndex, UserID, "*setfreq 1", 0
  DelPlaying BotIndex, UserID
 Else
  PrivateMessage BotIndex, UserID, "*shipreset", 0
 End If
ElseIf .Type = 5 And .Status = started And .Enabled Then 'conquer
 If KillerUserID > -1 Then ConquerPlayer BotIndex, UserID, KillerUserID
ElseIf .Type = 6 And .Enabled And KillerUserID > -1 Then 'bounty
 If UserID = .BountyRabbitUserIndex Then CapturedRabbit BotIndex, UserID, KillerUserID 'if the killed player was the bounty rabbit
ElseIf .Type = 7 And .Enabled And .Status = started Then 'freeelim
 If .Users(UserID).Losses >= .MaxDeaths Then
  If .Users(UserID).Playing Then
   PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " is out. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
   DelPlaying BotIndex, UserID
   UpdateRank .Users(UserID).Name, False, .Users(UserID).Wins, .Users(UserID).Losses
  End If
 End If
 If .Users(UserID).Wins >= .MaxDeaths Then
  PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(UserID).Name, 103 * .GameSound
  .Status = CHECK
  UpdateRank .Users(UserID).Name, True, .Users(UserID).Wins, .Users(UserID).Losses
 End If
' i = FindPlaying(BotIndex, .Users(KillerUserID).Name)
' If i > 0 Then
'  PublicMessage BotIndex, "*arena " + .Users(KillerUserID).Name + " got a kill. " + CStr(.Users(KillerUserID).Wins) + " wins " + CStr(.Users(KillerUserID).Losses) + " losses", 0
' End If
' i = FindPlaying(BotIndex, .Users(UserID).Name)
' If i > 0 Then
'  PublicMessage BotIndex, "*arena " + .Users(UserID).Name + " is killed. " + CStr(.Users(UserID).Wins) + " wins " + CStr(.Users(UserID).Losses) + " losses", 0
' End If
End If
End With
Exit Sub

FlyPaper:
AddTerminal BotIndex, "Error detected in HandleScoreChanges(): " + Err.Description, 12
Resume Next
End Sub

'Player ship changes
Public Sub HandleShipChanges(BotIndex As Byte, UserID As Integer)
On Error GoTo FlyPaper

If Bots(BotIndex).AutoSpec > 0 And Bots(BotIndex).AutoSpec <= Bots(BotIndex).Users(UserID).Losses And Bots(BotIndex).Users(UserID).Ship < 8 Then
 PrivateMessage BotIndex, UserID, "*spec", 0
 PrivateMessage BotIndex, UserID, "*spec", 0
End If

If Bots(BotIndex).Users(UserID).Ship < 8 And Bots(BotIndex).LockShips <> Bots(BotIndex).Users(UserID).Ship + 1 And Bots(BotIndex).LockShips > 0 Then
 PrivateMessage BotIndex, UserID, "*setship " + CStr(Bots(BotIndex).LockShips), 0
End If

If Bots(BotIndex).Enabled = 0 Then Exit Sub

With Bots(BotIndex).Users(UserID)
If Bots(BotIndex).Type = 1 And Bots(BotIndex).Status = started Then
 If .Playing Then
  If .Ship = 8 Then
   DelPlaying BotIndex, UserID
   UpdateRank .Name, False, .Wins, .Losses
  ElseIf Bots(BotIndex).ElimType >= javelim And Bots(BotIndex).ElimType <= javrace And .Ship <> 1 Then
   PrivateMessage BotIndex, UserID, "*setship 2", 0
   Exit Sub
  ElseIf Bots(BotIndex).ElimType >= wbelim And Bots(BotIndex).ElimType <= wbrace And .Ship <> 0 Then
   PrivateMessage BotIndex, UserID, "*setship 1", 0
   Exit Sub
  ElseIf Bots(BotIndex).ElimType = teamelim And .Freq > 1 Then
   DelPlaying BotIndex, UserID
   UpdateRank .Name, False, .Wins, .Losses
   PrivateMessage BotIndex, UserID, "*spec", 0
   PrivateMessage BotIndex, UserID, "*spec", 0
  End If
 Else
  If .Ship < 8 Then
   PrivateMessage BotIndex, UserID, "*spec", 0
   PrivateMessage BotIndex, UserID, "*spec", 0
  End If
 End If
ElseIf Bots(BotIndex).Type = 2 And Bots(BotIndex).Status = started Then
 If .Playing Then
  If .Freq = 1 Or .Ship = 8 Then DelPlaying BotIndex, UserID
 Else
  If .Freq = 0 And .Ship < 8 Then
   PrivateMessage BotIndex, UserID, "*setfreq 1", 0
  End If
 End If
ElseIf Bots(BotIndex).Type = 3 Then
 Select Case .Freq
 Case 0
  Select Case .Ship
  Case 3: PrivateMessage BotIndex, UserID, "*setship 2", 0
  Case 4: PrivateMessage BotIndex, UserID, "*setship 1", 0
  Case 5: PrivateMessage BotIndex, UserID, "*setship 3", 0
  Case 6
   If .Playing Then
    PrivateMessage BotIndex, UserID, "*setship 8", 0
   Else
    PrivateMessage BotIndex, UserID, "*setship " + CStr(Int(Rnd * 3) + 1), 0
   End If
  Case 7: If .Playing = 0 Then PrivateMessage BotIndex, UserID, "*setship " + CStr(Int(Rnd * 3) + 1), 0
  End Select
 Case 1
  Select Case .Ship
  Case 0: PrivateMessage BotIndex, UserID, "*setship 5", 0
  Case 1: PrivateMessage BotIndex, UserID, "*setship 4", 0
  Case 2: PrivateMessage BotIndex, UserID, "*setship 6", 0
  Case 6: If .Playing = 0 Then PrivateMessage BotIndex, UserID, "*setship " + CStr(Int(Rnd * 3) + 4), 0
  Case 7
   If .Playing Then
    PrivateMessage BotIndex, UserID, "*setship 7", 0
   Else
    PrivateMessage BotIndex, UserID, "*setship " + CStr(Int(Rnd * 3) + 4), 0
   End If
  End Select
 End Select
ElseIf Bots(BotIndex).Type = 4 Then
 Select Case .Freq
 Case 0
  Select Case .Ship
  Case 4: PrivateMessage BotIndex, UserID, "*setship 1", 0
  Case 5: PrivateMessage BotIndex, UserID, "*setship 2", 0
  Case 6: PrivateMessage BotIndex, UserID, "*setship 3", 0
  Case 7: PrivateMessage BotIndex, UserID, "*setship 4", 0
  End Select
 Case 1
  Select Case .Ship
  Case 0: PrivateMessage BotIndex, UserID, "*setship 5", 0
  Case 1: PrivateMessage BotIndex, UserID, "*setship 6", 0
  Case 2: PrivateMessage BotIndex, UserID, "*setship 7", 0
  Case 3: PrivateMessage BotIndex, UserID, "*setship 8", 0
  End Select
 End Select
ElseIf Bots(BotIndex).Type = 5 And Bots(BotIndex).Status = started Then
 ConquerCheckFreq BotIndex, UserID
ElseIf Bots(BotIndex).Type = 6 Then
 If UserID = Bots(BotIndex).BountyRabbitUserIndex Then 'player who changed ship/specced was the bounty rabbit
  If Bots(BotIndex).Users(UserID).Ship < 8 Then 'changed ship; regive the bounty cause it was reset
   If Bots(BotIndex).HasSysop Then
    PrivateMessage BotIndex, UserID, "*prize 5000", 0
   Else
    Dim b As Byte
    For b = 1 To 50
     PrivateMessage BotIndex, UserID, "*prize 100", 0
    Next
   End If
  Else 'quit to spec; choose new rabbit
   NewRabbit BotIndex, 3
  End If
 ElseIf Bots(BotIndex).BountyRabbitUserIndex = -1 Then 'there's no bounty rabbit
  NewRabbit BotIndex, 4
 End If
ElseIf Bots(BotIndex).Type = 7 And Bots(BotIndex).Status = started Then
 If .Playing Then 'if player is still in game (by rules)
  If .Ship = 8 Then 'now goes to spec
   DelPlaying BotIndex, UserID
   UpdateRank .Name, False, .Wins, .Losses
   PublicMessage BotIndex, "*arena " + .Name + " is out.", 0 'have to announce here, cause in plain elim it just forces player in spec after going to spec until game is over
  End If
 Else 'if not in game; logged in or specced
  If .Losses < Bots(BotIndex).MaxDeaths Then 'like above and not exceeded .maxdeaths by rules (not out)
   If .Ship < 8 Then 'got in ship (after spec or logging on while specced)
    If CheckPlayerCount(BotIndex, 2, False) Then
     AddPlaying BotIndex, UserID
     If InStr(LCase(GameBans), LCase(.Name)) = 0 Then 'this gameban check is in CheckPlayerCount and AddPlaying. we need it here too or other players will get confused
      PublicMessage BotIndex, "*arena " + .Name + " is in the game.", 0 'have to announce here, cause in plain elim it just forces player in spec after going to spec until game is over
     End If
    End If
   End If
  End If
 End If
End If
End With
Exit Sub

FlyPaper:
AddTerminal BotIndex, "Error detected in HandleShipChanges(): " + Err.Description, 12
Resume Next
End Sub

Function GetPlayerCoords(BotIndex As Byte, UserID As Integer) As String
Dim b As Byte, I As Integer, S As String
S = Chr(65 + Int(Bots(BotIndex).Users(UserID).X / (MAX_X \ 20))) & CStr(1 + Int(Bots(BotIndex).Users(UserID).Y / (MAX_Y \ 20)))
I = Val(Mid(S, 2))
If I < 9 Then S = S + " [Top-"
If I >= 9 And I <= 12 Then S = S + " ["
If I > 12 Then S = S + " [Bottom-"
b = Asc(Left(S, 1))
If b < 73 Then S = S + "Left]"
If b >= 73 And b <= 76 Then S = S + "Center]"
If b > 76 Then S = S + "Right]"
GetPlayerCoords = S
End Function

Sub CheckAnsweringMachine(BotIndex As Byte, Name As String)
Dim I As Integer, I2 As Integer, TotalMsgs(MAX_USERS) As Integer 'To only report how many messages each player has received
With Bots(BotIndex)
For I = 1 To LastAMachMsg
 If (LCase(Name) = LCase(AMach(I).To) Or AMach(I).To = "") And AMach(I).Sent And AMach(I).ReadSent = 0 Then
  For I2 = 0 To .LastUser
   If .Users(I2).Name > "" Then
    If LCase(Name) = LCase(.Users(I2).Name) Or AMach(I).To = "" Then TotalMsgs(I2) = TotalMsgs(I2) + 1
   End If
  Next
 End If
Next
For I2 = 0 To .LastUser
 If TotalMsgs(I2) > 0 Then
  PrivateMessage BotIndex, I2, "Answering Machine: You have received " + CStr(TotalMsgs(I2)) + " message(s)", 16 * .GameSound
 End If
Next
End With
End Sub

Sub LoadMessages()
Dim freefilenumber As Integer, S As String, I As Integer, I2 As Integer, I3 As Integer, I4 As Integer, I5 As Integer, I6 As Integer, I7 As Integer, I8 As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Messages.txt" For Input As freefilenumber
 LastAMachMsg = 0
 Do Until EOF(freefilenumber)
nextline:
  Line Input #freefilenumber, S
  I = InStr(S, "")
  I2 = InStr(I + 1, S, "")
  I3 = InStr(I2 + 1, S, "")
  I4 = InStr(I3 + 1, S, "")
  I5 = InStr(I4 + 1, S, "")
  I6 = InStr(I5 + 1, S, "")
  I7 = InStr(I6 + 1, S, "")
  If I > 0 Then
   LastAMachMsg = LastAMachMsg + 1
   With AMach(LastAMachMsg)
   .From = Left(S, I - 1)
   If .From = "" Then LastAMachMsg = LastAMachMsg - 1: GoTo nextline
   If I2 > 0 Then
    .To = Mid(S, I + 1, I2 - I - 1)
    If I3 > 0 Then
     .Msg = Mid(S, I2 + 1, I3 - I2 - 1)
     If I4 > 0 Then
      .Subject = Mid(S, I3 + 1, I4 - I3 - 1)
      If I5 > 0 Then
       .ReadSent = Mid(S, I4 + 1, I5 - I4 - 1)
       If I6 > 0 Then
        .Sent = Mid(S, I5 + 1, I6 - I5 - 1)
        If I7 > 0 Then
         .Anonymous = Mid(S, I6 + 1, I7 - I6 - 1)
         .Date = Mid(S, I7 + 1)
        End If
       End If
      End If
     End If
    End If
   End If
   End With
  End If
  If LastAMachMsg = MAX_AMACHS Then Exit Do
 Loop
ErrHandler:
Close freefilenumber
AddTerminal 0, "Answering Machine loaded. " + CStr(LastAMachMsg) + " messages", 9
End Sub

Sub SaveMessages()
Dim I As Long, freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
ChDrive App.Path: ChDir App.Path
Open "Messages.txt" For Output As freefilenumber
 Print #freefilenumber, "FROM,TO,MESSAGE,SUBJECT,READ,SENT,ANONYMOUS,DATE"
 For I = 1 To LastAMachMsg
  With AMach(I)
  Print #freefilenumber, .From; ""; .To; ""; .Msg; ""; .Subject; ""; .ReadSent; ""; .Sent; ""; .Anonymous; ""; .Date
  End With
 Next
ErrHandler:
Close freefilenumber
End Sub

Sub SetErrorChannel(BotIndex As Byte, UserID As Integer, Channel As String)
If Channel > "" Then
 PublicMessage BotIndex, "?chat=" + Channel, 0
 PrivateMessage BotIndex, UserID, "Broadcasting errors on channel " + Channel, 0
Else
 PrivateMessage BotIndex, UserID, "Broadcasting errors to no channel", 0
End If
Bots(BotIndex).ErrorChannel = Channel
End Sub

Function GetType(AnyFormat, GiveOnlyNumbers As Boolean, Default) As String
Dim S As String
S = Trim(LCase(AnyFormat))
If GiveOnlyNumbers Then GoTo wantnumberoutput
Select Case S
Case 0: GetType = "N"
Case 1: GetType = "E"
Case 2: GetType = "Z"
Case 3: GetType = "S"
Case 4: GetType = "D"
Case 5: GetType = "C"
Case 6: GetType = "B"
Case 7: GetType = "F"
Case Else: GoTo wantnumberoutput
End Select
Exit Function
wantnumberoutput:
Select Case S
Case "n": GetType = 0
Case "e": GetType = 1
Case "z": GetType = 2
Case "s": GetType = 3
Case "d": GetType = 4
Case "c": GetType = 5
Case "b": GetType = 6
Case "f": GetType = 7
Case Else
 If GiveOnlyNumbers Then
  If Val(S) < 0 Or Val(S) > 7 Or Not IsNumeric(S) Then
   GoTo 1
  Else
   GetType = Val(S)
  End If
 Else
1
  If Default > "" Then GetType = Default Else GetType = -1
 End If
End Select
End Function

Function GetSpawnConnected(BotIndex) As String
GetSpawnConnected = "None" 'don't need to check for .Spawnconnected=0, it will be reset in Sub ResetSession along with .Sock. so just check the .Sock for type of connection (local or remote)
If Long2IP(Bots(BotIndex).Sock.sin_addr) = Bots(BotIndex).LocalIP And ntohs(Bots(BotIndex).Sock.sin_port) = Bots(BotIndex).LocalPort Then GetSpawnConnected = "Local" 'ip/port the bot is on right before termination
If Long2IP(Bots(BotIndex).Sock.sin_addr) = Bots(BotIndex).RemoteIP And ntohs(Bots(BotIndex).Sock.sin_port) = Bots(BotIndex).RemotePort Then GetSpawnConnected = "Remote"
End Function

Function GetBotInFocus(BotIndex As Byte) As Byte
If BotIndex < 0 Then BotIndex = 0
If BotIndex > UBound(Bots) Then BotIndex = UBound(Bots)
GetBotInFocus = BotIndex
End Function

Function GetMacID(BotIndex As Byte, MacID As String) As Long
GetMacID = IIf(IsNumeric(Bots(BotIndex).MacID), Bots(BotIndex).MacID, MachineID)
End Function
